##python3-biopython is not built in Fedora yet
%if 0%{?fedora}
%global with_python3 0
%else
%global with_python3 0
%endif

%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

##  Filtering of private libraries 
%global _privatelibs  ^%{python_sitearch}/prody/.*\\.so$
%global __provides_exclude_from ^(%{_privatelibs})$
%global __requires_exclude_from ^(%{_privatelibs})$

Name: ProDy
Summary: Application for protein structure, dynamics and sequence analysis
Version: 1.5.1
Release: 6%{?dist}
License: GPLv3+
Group: Applications/Engineering
URL: http://www.csb.pitt.edu/ProDy
Source0: http://pypi.python.org/packages/source/P/%{name}/%{name}-%{version}.tar.gz

BuildRequires: python2-devel, python-nose
BuildRequires: numpy, python-matplotlib

Requires: scipy

## Explicit library require for using plotting functions
Requires: python-matplotlib

### Pyparsing is used to define the atom selection grammar
### Biopython KDTree package and pairwise2 module are used for distance based
## atom selections and pairwise sequence alignment, respectively.
#
### argparse is used to implement applications and provided for
## compatibility with Python 2.6.
%if 0%{?epel}
Requires: python-argparse
Requires: pyparsing, python-biopython >= 1.62
Requires: ipython
%else
Requires: python-biopython
Requires: python-ipython
%endif

%description
ProDy is a free and open-source Python package for protein structure, dynamics,
and sequence analysis.  It allows for comparative analysis and modeling of 
protein structural dynamics and sequence co-evolution.  Fast and flexible ProDy
API is for interactive usage as well as application development.  ProDy also  
comes with several analysis applications and a graphical user interface for 
visual analysis. 
- Visit http://www.csb.pitt.edu/ProDy/ -

%if 0%{?with_python3}
%package -n python3-%{name}
Summary: Application for protein structure, dynamics and sequence analysis

BuildRequires: python3-devel, python3-nose
BuildRequires: python3-numpy, python3-matplotlib

Requires: python3-scipy
Requires: python3-biopython
Requires: python3-ipython

## Explicit library require for using plotting functions
Requires: python3-matplotlib


%description -n python3-%{name}
ProDy is a free and open-source Python package for protein structure, dynamics,
and sequence analysis.  It allows for comparative analysis and modeling of 
protein structural dynamics and sequence co-evolution.  Fast and flexible ProDy
API is for interactive usage as well as application development.  ProDy also  
comes with several analysis applications and a graphical user interface for 
visual analysis. 
- Visit http://www.csb.pitt.edu/ProDy/ -
%endif # with_python3

%prep
%setup -q -n %{name}-%{version}

## Removing bundled files
rm prody/atomic/pyparsing*
rm -rf prody/KDTree
rm prody/proteins/pairwise2.py prody/proteins/cpairwise2.c
rm prody/apps/argparse.py

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif # with_python3

%build
%{__python2} setup.py build

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
popd
%endif # with_python3

%install
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install --skip-build --root $RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT%{_bindir}/prody $RPM_BUILD_ROOT%{_bindir}/python3-prody
mv $RPM_BUILD_ROOT%{_bindir}/evol $RPM_BUILD_ROOT%{_bindir}/python3-evol
popd
%endif

%{__python2} setup.py install --skip-build --root $RPM_BUILD_ROOT

%files
%doc PKG-INFO README.rst
%if 0%{?epel} < 7
%doc LICENSE.rst
%else
%license LICENSE.rst
%endif
%{_bindir}/prody
%{_bindir}/evol
%{python2_sitearch}/prody
%{python2_sitearch}/%{name}-%{version}-*.egg-info

%if 0%{?with_python3}
%files -n python3-%{name}
%license LICENSE.rst
%doc PKG-INFO README.rst
%{_bindir}/python3-prody
%{_bindir}/python3-evol
%{python3_sitearch}/prody
%{python3_sitearch}/%{name}-%{version}-*.egg-info
%endif

%changelog
* Mon May 04 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.5.1-6
- Fixed License tag
- Python3 disabled because of missing BR package

* Mon May 04 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.5.1-5
- Rebuild

* Sun May 03 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.5.1-4
- Built with Python3
- Built on EPEL6

* Fri Aug 15 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Jun 06 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Jan 03 2014 Antonio Trande <sagitter@fedoraproject.org> 1.5.1-1
- Update to 1.5.1

* Mon Nov 25 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.10-1
- Update to 1.4.10

* Sat Nov 16 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.9-1
- Update to 1.4.9
- Remove 'cpairwise2.c' file

* Wed Nov 06 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.8-1
- Re-defined required packages for EPEL
- Update to 1.4.8

* Thu Oct 24 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.6-2
- Defined a python2 macro only for Fedora

* Wed Oct 23 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.6-1
- Update to 1.4.6
- Defined python-argparse required package for EPEL
- Spec file renamed ProDy 
- Defined a python2 macro only for Fedora 

* Sun Sep 15 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.4-3
- Bundled files removed
- Add new required packages (pyparsing, python-biopython)

* Mon Aug 12 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.4-2
- Added python-matplotlib and python-ipython as Requires
- Perform filtering private libraries 
- Fix some 'non-executable-script' warnings
- Add a Python shebang

* Mon Aug 12 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.4-1
- Initial build
